package me.unurled.raxen.commands.admin;

import me.unurled.raxen.Raxen;
import me.unurled.raxen.utils.Utils;
import net.kyori.adventure.text.TextComponent;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

public class TestHoloCommand implements TabExecutor {

    private Raxen main;

    public TestHoloCommand(Raxen main) {
        this.main = main;
    }

    /**
     * @param sender  Source of the command 
     * @param command Command which was executed
     * @param label   Alias of the command which was used
     * @param args    Passed command arguments
     * @return
     */
    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (sender instanceof Player player) {
            if (player.hasPermission("raxen.testholo.cmd")) {
                // spawn a hologram
                if (args.length > 0) {
                    if (args[0].equalsIgnoreCase("text")) {
                        main.getManager().getLibsManager().getHolographicDisplay().createHologram("test holo", player.getLocation().add(0.0, 2.0, 0.0));
                    } else if (args[0].equalsIgnoreCase("item")) {
                        main.getManager().getLibsManager().getHolographicDisplay().createHologram(player.getInventory().getItemInMainHand(), player.getLocation().add(0.0, 2.0, 0.0));
                    }
                } else {
                    Utils.msgPlayer(player, "You need to use the correct syntax :", "/" + label + " [text | item]");
                }
            } else {
                Utils.msgPlayer(player, (TextComponent) Utils.noPerms());
            }
        } else {
            Utils.errorConsoleSender(sender);
        }
        return true;
    }

    /**
     * @param sender  Source of the command.  For players tab-completing a 
     *                command inside of a command block, this will be the player, not
     *                the command block.
     * @param command Command which was executed
     * @param label   Alias of the command which was used
     * @param args    The arguments passed to the command, including final
     *                partial argument to be completed
     * @return
     */
    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        return null;
    }
}
