package me.unurled.raxen.manager.server;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.utils.Utils;
import me.unurled.raxen.utils.libs.*;
import org.bukkit.Bukkit;

public class LibsManager {
    @Getter
    private final ProtocolManager protocolManager;
    @Getter
    private final LuckPerm luckPerm;
    @Getter
    private final Vault vault;
    @Getter
    private final MongoDB mongoDB;
    @Getter
    private static Mysql mysql;
    @Getter
    private PlaceHolderAPI placeHolderAPI;
    @Getter
    private CitizensApi citizens;
    @Getter
    private HolographicDisplay holographicDisplay;

    public LibsManager(Raxen main) {
        this.luckPerm = new LuckPerm(main);
        this.luckPerm.register();
        this.vault = new Vault(main);
        this.protocolManager = new ProtocolManager(main);
        this.mongoDB = new MongoDB();
        this.placeHolderAPI = new PlaceHolderAPI(main);
        this.citizens = new CitizensApi(main);
        if (!Bukkit.getPluginManager().isPluginEnabled("HolographicDisplays")) {
            Utils.error("*** HolographicDisplays is not installed or not enabled. ***", "*** This plugin will be disabled. ***");
            main.disable();
        } else {
            holographicDisplay = new HolographicDisplay(main);
        }
    }
}
